package com.eitc.modules.message.service;

import com.eitc.common.service.CrudService;
import com.eitc.modules.message.dto.SysSmsDTO;
import com.eitc.modules.message.entity.SysSmsEntity;

/**
 * 短信
 *
 * @author Mark eitc@163.com
 */
public interface SysSmsService extends CrudService<SysSmsEntity, SysSmsDTO> {

    /**
     * 发送短信
     * @param smsCode   短信编码
     * @param mobile   手机号
     * @param params   短信参数
     */
    void send(String smsCode, String mobile, String params);

    SysSmsEntity getBySmsCode(String smsCode);

}

